# KISC-32 C++ Compiler
https://git.oggyp.com/coding/kisc-32-compiler


## Overview
This compiler serves to compile KISC-32 Assembly (.kisc) files, compliant with 
the KISC-32 specification. The design of this compiler is based on the offical 
Python implementation and is intended to eventually supercede it.


## Prerequisites
- A C++ compiler compatible with C++17. As this program used GCC, I recommend 
  using it to avoid strange bugs
- A Linux or macOS machine. This program has not been tested on Windows


## Usage
1. Download the files
2. In a terminal, navigate to the corresponding directory
3. Use a C++ compiler to compile the project
4. Run the executable (you may need to prefix with `./`)
5. Follow the instructions included


## Contributing Guidelines
- Don't leave it a buggy mess. That's my job
- Leave comments explaning __why__ and __how__ (if it's not *really* obvious)
- Try to keep consistent with the surrounding code style
- Keep the obsceneties to a minimum
- Be nice and be clear in discussions, program messages, and the code

For more info, see CONTRIBUTING.


## Other Comments
None so far :D


## See Also
- KISC-32 Official Implementation: https://git.oggyp.com/kElnaDev/kisc-32
- kElnaDev: https://git.oggyp.com/kElnaDev/
- OggyP: https://git.oggyp.com/OggyP/