/*
  KISC-32 Compiler | tokens.hpp
  Copyright (C) 2024  Kaelan Carlos

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <https://www.gnu.org/licenses/>.

  Contact email: kelna@kelna.dev
*/

#include <iostream>

namespace lang
{
  std::string instr_toks[] = {
    "nop",
    "rtn",
    "ldr",
    "ldm",
    "mvr",
    "mvm",
    "ser",
    "sem",
    "flg",
    "ufl",
    "not",
    "and",
    "orr",
    "xor",
    "lsl",
    "lsr",
    "asl",
    "asr",
    "neg",
    "add",
    "sub",
    "mpy",
    "div",
    "inc",
    "dec",
    "isrt",
    "iend",
    "iadd",
    "isub",
    "impy",
    "idiv",
    "cmp",
    "jlt",
    "jle",
    "jeq",
    "jge",
    "jgt",
    "jne",
    "jrc",
    "jrp",
    "jrs",
    "jrz",
    "jnc",
    "jnp",
    "jns",
    "jnz",
    "jmp",
    "fnc",
    "otv",
    "otr",
    "otm",
    "rep",
    "wrp"
  };

  bool instr_vars[] = {
    false,
    false,
    true,
    true,
    true,
    true,
    true,
    true,
    false,
    false,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    true,
    false,
    false,
    false,
    false,
    false,
    false,
    true,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    false,
    true,
    true,
    true,
    true,
    true
  };

  int instr_dlens[] = {
    0,
    0,
    2,
    2,
    2,
    2,
    2,
    2,
    1,
    1,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    2,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    4,
    2,
    2,
    2,
    2,
    2
  };

  char instr_ops[][2] = {
    {' ', ' '},
    {' ', ' '},
    {'r', 'm'},
    {'m', 'r'},
    {'r', 'r'},
    {'m', 'm'},
    {'r', 'v'},
    {'m', 'v'},
    {'f', ' '},
    {'f', ' '},
    {'r', ' '},
    {'r', 'c'},
    {'r', 'c'},
    {'r', 'c'},
    {'r', ' '},
    {'r', ' '},
    {'r', ' '},
    {'r', ' '},
    {'r', ' '},
    {'r', 'c'},
    {'r', 'c'},
    {'r', 'c'},
    {'r', 'c'},
    {'r', ' '},
    {'r', ' '},
    {'c', ' '},
    {' ', ' '},
    {'c', ' '},
    {'c', ' '},
    {'c', ' '},
    {'c', ' '},
    {'r', 'c'},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'b', ' '},
    {'r', ' '},
    {'r', ' '},
    {'m', ' '},
    {'r', 'p'},
    {'p', 'r'}
  };

  std::string reg_toks[] = {
    "pc",
    "ri",
    "sp",
    "ra",
    "rb",
    "rc",
    "rd",
    "rf",
    "rm",
    "rn",
    "r0",
    "r1",
    "r2",
    "r3",
    "r4",
    "r5",
    "r6",
    "r7"
  };

  int reg_addrs[] = {
    0,
    4,
    8,
    12,
    16,
    20,
    24,
    28,
    32,
    36,
    40,
    44,
    48,
    52,
    56,
    60,
    64,
    68
  };

  std::string fvs_toks[] = {
    "fi",
    "cv",
    "fz",
    "fs",
    "fp",
    "fc",
    "f1",
    "f0"
  };

  int fvs_bits[] = {
    23,
    24,
    26,
    27,
    28,
    29,
    30,
    31
  };

  bool fvs_edits[] = {
    true,
    false,
    true,
    true,
    true,
    true,
    false,
    false
  };
}